#ifndef __IRQ_H__

#define __IRQ_H__

#include <Types.h>
#include <IO.h>
#include <IDT.h>
#include <Asm.h>

#define MAX_IRQ 16
#define IRQ_VECTOR 0x20

typedef void (*IRQHandler_t)(void);

extern void EnableIRQ(int);
extern void DisableIRQ(int);
extern void RegisterIRQHandler(int, IRQHandler_t);
extern void UnregisterIRQHandler(int);
extern void UnidentifiedIRQ(void);
extern void HandleIRQ(int);


static unsigned short	irqMask = 0xfffb;

#define	irqMask0_7	(unsigned char)(irqMask&0xff)
#define	irqMask8_15	(unsigned char)((irqMask>>8)&0xff)


static IRQHandler_t	IRQHandler[MAX_IRQ];


#endif
